
void float_to_int16_sse(int16_t *dst, const float *src, long len)
{
    x86_reg reglen = len;
    __asm__ volatile(
        "add        %0          , %0        \n\t"
        "lea         (%2,%0,2)  , %2        \n\t"
        "add        %0          , %1        \n\t"
        "neg        %0                      \n\t"
        "1:                                 \n\t"
        "cvtps2pi    (%2,%0,2)  , %%mm0     \n\t"
        "cvtps2pi   8(%2,%0,2)  , %%mm1     \n\t"
        "cvtps2pi  16(%2,%0,2)  , %%mm2     \n\t"
        "cvtps2pi  24(%2,%0,2)  , %%mm3     \n\t"
        "packssdw   %%mm1       , %%mm0     \n\t"
        "packssdw   %%mm3       , %%mm2     \n\t"
        "movq       %%mm0       ,  (%1,%0)  \n\t"
        "movq       %%mm2       , 8(%1,%0)  \n\t"
        "add        $16         , %0        \n\t"
        " js 1b                             \n\t"
        "emms                               \n\t"
        :"+r"(reglen), "+r"(dst), "+r"(src)
    );
}

void float_to_int16_interleave2_sse(int16_t *dst, const float **src, long len)
{
    x86_reg reglen = len;
    const float *src0 = src[0];
    const float *src1 = src[1];
    __asm__ volatile(
        "shl $2, %0 \n"
        "add %0, %1 \n"
        "add %0, %2 \n"
        "add %0, %3 \n"
        "neg %0 \n"
        "1:                         \n"
        "cvtps2pi  (%2,%0), %%mm0   \n"
        "cvtps2pi 8(%2,%0), %%mm1   \n"
        "cvtps2pi  (%3,%0), %%mm2   \n"
        "cvtps2pi 8(%3,%0), %%mm3   \n"
        "packssdw    %%mm1, %%mm0   \n"
        "packssdw    %%mm3, %%mm2   \n"
        "movq        %%mm0, %%mm1   \n"
        "punpcklwd   %%mm2, %%mm0   \n"
        "punpckhwd   %%mm2, %%mm1   \n"
        "movq        %%mm0,  (%1,%0)\n"
        "movq        %%mm1, 8(%1,%0)\n"
        "add $16, %0                \n"
        "js 1b                      \n"
        "emms                       \n"
        :"+r"(reglen), "+r"(dst), "+r"(src0), "+r"(src1)
    );
}

